SystemOrganization addCategory: #Jihachol!

TestCase subclass: #JhcBundangLineTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 13:12'!
setUp

	super setUp.
	line := JhcLine bundang.
	
	

	! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 22:35'!
testDogok

	| s |
	s := line stations at: 3.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Dogok'.
	self assert: s id equals: 'K217'! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 22:40'!
testGaepoDong

	| s |
	s := line stations at: 5.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Gaepo-dong'.
	self assert: s id equals: 'K219'! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 22:37'!
testGuryong

	| s |
	s := line stations at: 4.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Guryong'.
	self assert: s id equals: 'K218'! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 22:35'!
testHanti

	| s |
	s := line stations at: 2.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Hanti'.
	self assert: s id equals: 'K216'! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 22:47'!
testOri

	| s |
	s := line stations at: 18.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Ori'.
	self assert: s id equals: 'K232'! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 22:33'!
testSeolleung

	| s |
	s := line stations at: 1.
	self assert: s line equals: 'Bundang'.
	self assert: s name equals: 'Seolleung'.
	self assert: s id equals: 'K215'! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 12:54'!
testTimeSpanFromBojeongToGaepoDong

	| station1 station2 |
	station1 := line stations at: 5.
	station2 := line stations at: 20.
	self assert: station1 name equals: 'Gaepo-dong'.
	self assert: station2 name equals: 'Bojeong'.
	self assert: (station1 timespanMinutesTo: station2) equals: 40! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 12:16'!
testTimeSpanFromDogokToSeolleung

	| seolleung dogok |
	seolleung := line stations at: 1.
	dogok := line stations at: 3.
	self assert: seolleung name equals: 'Seolleung'.
	self assert: dogok name equals: 'Dogok'.
	self assert: (seolleung timespanMinutesTo: dogok) equals: 4! !

!JhcBundangLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 12:23'!
testTimeSpanFromSuseoToKyungwonUniv

	| suseo kyungwonUniv |
	suseo := line stations at: 7.
	kyungwonUniv := line stations at: 9.
	self assert: suseo name equals: 'Suseo'.
	self assert: kyungwonUniv name equals: 'Kyungwon Univ.'.
	self assert: (suseo timespanMinutesTo: kyungwonUniv) equals: 7! !

TestCase subclass: #JhcLine6Test
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 18:59'!
setUp

	super setUp.
	line := JhcLine line6! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 10:12'!
testBonghwasan

	| station |
	station := line stations at: 38.
	self assert: station line equals: '6'.
	self assert: station id equals: '647'.
	self assert: station name equals: 'Bonghwasan'! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 19:15'!
testEungam

	| station |
	station := line stations at: 1.
	self assert: station line equals: '6'.
	self assert: station id equals: '610'.
	self assert: station name equals: 'Eungam'! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 11:26'!
testGusan

	| station |
	station := line stations at: 6.
	self assert: station line equals: '6'.
	self assert: station id equals: '615'.
	self assert: station name equals: 'Gusan'! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 19:07'!
testMangwon

	| station |
	station := line stations at: 12.
	self assert: station line equals: '6'.
	self assert: station id equals: '621'.
	self assert: station name equals: 'Mangwon'! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 19:16'!
testSaejeol

	| station |
	station := line stations at: 7.
	self assert: station line equals: '6'.
	self assert: station id equals: '616'.
	self assert: station name equals: 'Saejeol
(Sinsa)'! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 10:55'!
testStraightLineStations

	self assert: (line stations at: 1) name equals: 'Eungam'.
	self assert: (line stations at: 7) name equals: 'Saejeol
(Sinsa)'.
	self assert: (line stations at: 8) name equals: 'Jeungsan
(Myongji Univ.)'.
	self assert: (line stations at: 9) name equals: 'Digital Media City'.
	"..."
	self assert: (line stations at: 36) name equals: 'Taereung'.
	self assert: (line stations at: 37) name equals: 'Hwarangdae
(Seoul Women''s Univ.)'..
	self assert: (line stations at: 38) name equals: 'Bonghwasan'.! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 11:15'!
testTimeSpanFromEungamToBonghwasan

	| station1 station2 |
	station1 := line stations at: 1.
	station2 := line stations at: 38.
		
	self assert: (station1 timespanMinutesTo: station2) equals: 64! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 11:32'!
testTimeSpanFromYeokchonToGusan

	| station1 station2 |
	station1 := line stations at: 2.
	station2 := line stations at: 6.
		
	self assert: (station1 timespanMinutesTo: station2) equals: 9! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 11:38'!
testTimeSpanFromYeokchonToSaejeol

	| station1 station2 |
	station1 := line stations at: 2.
	station2 := line stations at: 7.
		
	self assert: (station1 timespanMinutesTo: station2) equals: 14! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 11:27'!
testYeokchon

	| station |
	station := line stations at: 2.
	self assert: station line equals: '6'.
	self assert: station id equals: '611'.
	self assert: station name equals: 'Yeokchon'! !

TestCase subclass: #JhcLine8Test
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine8Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 13:16'!
setUp

	super setUp.
	line := JhcLine line8! !

!JhcLine8Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 13:29'!
testAmsa

	| station |
	station := line stations at: 1.
	self assert: station line equals: '8'.
	self assert: station name equals: 'Amsa'.
	self assert: station id equals: '810'! !

!JhcLine8Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 15:05'!
testSongpa

	| station |
	station := line stations at: 7.
	self assert: station line equals: '8'.
	self assert: station name equals: 'Songpa'.
	self assert: station id equals: '816'! !

!JhcLine8Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 11:10'!
testStationAndVertexHandshake

	| station |
	station := JhcStation new.
	self assert: (station graphVertex isKindOf: Vertex).
	self assert: (station graphVertex masterObject == station)! !

!JhcLine8Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 15:20'!
testTimeSpanFromAmsaToSongpa

	| station1 station2 |
	station1 := line stations at: 1.
	station2 := line stations at: 7.

	self assert: (station1 timespanMinutesTo: station2) equals: 13! !

!JhcLine8Test methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 15:21'!
testTimeSpanFromBokjeongToSanseong

	| station1 station2 |
	station1 := line stations at: 11.
	station2 := line stations at: 12.

	self assert: (station1 timespanMinutesTo: station2) equals: 4! !

TestCase subclass: #JhcLineJooyungHanTest
	instanceVariableNames: 'line scrum tdd refactoring pp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:56'!
setUp
	line := JhcLine new.
	line line: 'Jooyung han'.
	line idPrefix: 'JH'.
	
	scrum := line addStationNamed: 'Scrum'.
	tdd := line addStationNamed: 'TDD'.
	refactoring := line addStationNamed: 'Refactoring'.
	pp := line addStationNamed: 'PP'.
	
	refactoring connect: tdd.
	tdd connect: pp.
	pp connect: scrum.
	scrum connect: refactoring.! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:48'!
testCircularLine
	self assert: (refactoring neighbors includes: tdd).
	self assert: (tdd neighbors includes: pp).
	self assert: (pp neighbors includes: scrum).
	self assert: (scrum neighbors includes: refactoring).! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:26'!
testStationCount
	self assert:4 equals: line stations size! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 01:04'!
testTimeSpan
	|cost|
	cost := JhcStation defaultCost.
	self assert: 0 equals: (refactoring timespanMinutesTo: refactoring).
	self assert: cost equals: (refactoring timespanMinutesTo: tdd).
	self assert: cost*2 equals: (refactoring timespanMinutesTo: pp).! !

TestCase subclass: #JhcRoutingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 09:28'!
testBundangLine

	| line |
	line := OrderedCollection new.
	line add: (JhcStation newName: 'Seolleung' line: 'Bundang' id: 'K215').
	line add: (JhcStation newName: 'Hanti' line: 'Bundang' id: 'K216').
	line add: (JhcStation newName: 'Dogok' line: 'Bundang' id: 'K217').
	line add: (JhcStation newName: 'Guryong' line: 'Bundang' id: 'K218').
	line add: (JhcStation newName: 'Gaepo-dong' line: 'Bundang' id: 'K219').
	line add: (JhcStation newName: 'Daemosan' line: 'Bundang' id: 'K220').
	line add: (JhcStation newName: 'Suseo' line: 'Bundang' id: 'K221').
	line add: (JhcStation newName: 'Bokjeong' line: 'Bundang' id: 'K222').
	line add: (JhcStation newName: 'Kyungwon Univ.' line: 'Bundang' id: 'K223').
	line add: (JhcStation newName: 'Taepyeong' line: 'Bundang' id: 'K224').
	line add: (JhcStation newName: 'Moran' line: 'Bundang' id: 'K225').
	line add: (JhcStation newName: 'Yatap' line: 'Bundang' id: 'K226').
	line add: (JhcStation newName: 'Imae' line: 'Bundang' id: 'K227').
	line add: (JhcStation newName: 'Seohyeon' line: 'Bundang' id: 'K228').
	line add: (JhcStation newName: 'Sunae' line: 'Bundang' id: 'K229').
	line add: (JhcStation newName: 'Jeongja' line: 'Bundang' id: 'K230').
	line add: (JhcStation newName: 'Migeum' line: 'Bundang' id: 'K231').
	line add: (JhcStation newName: 'Ori' line: 'Bundang' id: 'K232').
	line add: (JhcStation newName: 'Jukjeon' line: 'Bundang' id: 'K233').
	line add: (JhcStation newName: 'Bojeong' line: 'Bundang' id: 'K234').

	line doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	self assert: ((line at:1) timespanMinutesTo: (line at:15)) equals: 28! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 11:25'!
testLine8

	| line |
	line := OrderedCollection new.
	line add: (JhcStation newName: 'Amsa' line: '8' id: '810').
	line add: (JhcStation newName: 'Cheonho(Pungnaptoseong)' line: '8' id: '811').
	line add: (JhcStation newName: 'Gangdong-gu Office' line: '8' id: '812').
	line add: (JhcStation newName: 'Mongchontoseong(World Peace Gate)' line: '8' id: '813').
	line add: (JhcStation newName: 'Jamsil(Songpa-gu Office)' line: '8' id: '814').
	line add: (JhcStation newName: 'Seokchon' line: '8' id: '815').
	line add: (JhcStation newName: 'Songpa' line: '8' id: '816').
	line add: (JhcStation newName: 'Garak Market' line: '8' id: '817').
	line add: (JhcStation newName: 'Munjeong' line: '8' id: '818').
	line add: (JhcStation newName: 'Jangji' line: '8' id: '819').
	line add: (JhcStation newName: 'Bokjeong' line: '8' id: '820').
	line add: (JhcStation newName: 'Sanseong' line: '8' id: '821').
	line add: (JhcStation newName: 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' line: '8' id: '822').
	line add: (JhcStation newName: 'Dandaegogeori' line: '8' id: '823').
	line add: (JhcStation newName: 'Sinheung' line: '8' id: '824').
	line add: (JhcStation newName: 'Sujin' line: '8' id: '825').
	line add: (JhcStation newName: 'Moran' line: '8' id: '826').

	line doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	self assert: ((line at:10) timespanMinutesTo: (line at:15)) equals: 10! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:27'!
testOneSegment

	| s t g |
	s := JhcStation newName: 'Hapjeong' line: 2 id: 238.
	t := JhcStation newName: 'HongIk Univ.' line: 2 id: 239.
	g := JhcSegment newTimespanMinutes: 2.

	s setStationAccess: t in: g.
	self assert: (s timespanMinutesTo: t) equals:2! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/27/2009 11:34'!
testTransferFromBundangLineToLine8AtBokjeong

	| line8 bundangLine |
	line8 := OrderedCollection new.
	line8 add: (JhcStation newName: 'Munjeong' line: '8' id: '818').
	line8 add: (JhcStation newName: 'Jangji' line: '8' id: '819').
	line8 add: (JhcStation newName: 'Bokjeong' line: '8' id: '820').
	line8 add: (JhcStation newName: 'Sanseong' line: '8' id: '821').
	line8 add: (JhcStation newName: 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' line: '8' id: '822').

	line8 doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	
	bundangLine := OrderedCollection new.
	bundangLine add: (JhcStation newName: 'Gaepo-dong' line: 'Bundang' id: 'K219').
	bundangLine add: (JhcStation newName: 'Daemosan' line: 'Bundang' id: 'K220').
	bundangLine add: (JhcStation newName: 'Suseo' line: 'Bundang' id: 'K221').
	bundangLine add: (JhcStation newName: 'Bokjeong' line: 'Bundang' id: 'K222').
	bundangLine add: (JhcStation newName: 'Kyungwon Univ.' line: 'Bundang' id: 'K223').
	bundangLine add: (JhcStation newName: 'Taepyeong' line: 'Bundang' id: 'K224').
	bundangLine add: (JhcStation newName: 'Moran' line: 'Bundang' id: 'K225').

	bundangLine doCouple: [:a :b| a graphVertex connect: b graphVertex cost: 2 ].
	(line8 at: 3) graphVertex connect: (bundangLine at: 4) graphVertex cost: 7. "transfer link"
	
	self assert: (line8 first timespanMinutesTo: bundangLine last) equals: 17! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/26/2009 19:45'!
testTwoSegment

	| s t u |
	s := JhcStation newName: 'Hapjeong' line: 2 id: 238.
	t := JhcStation newName: 'HongIk Univ.' line: 2 id: 239.
	u := JhcStation newName: 'ShinChon' line: 2 id: 240.

	self revisit: 'I think JhcSegment is not doing anything here. Simply CostEdge will be good enough.'.

	s graphVertex connect: t graphVertex cost: 2.
	t graphVertex connect: u graphVertex cost: 2.
	self assert: (s timespanMinutesTo: u) equals: 4! !

Object subclass: #IntegerStream
	instanceVariableNames: 'current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:35'!
initialize
	current := 0! !

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:35'!
next
	|ret|
	ret := current.
	current := current + 1.
	^ret! !

Object subclass: #JhcLine
	instanceVariableNames: 'line idPrefix stations integerStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 13:12'!
bundang

	| inst |
	inst := self new.
	inst line: 'Bundang'.
	inst idPrefix: 'K'.
	
	#('Seolleung' 'Hanti' 'Dogok' 'Guryong' 'Gaepo-dong' 'Daemosan' 'Suseo' 'Bokjeong' 'Kyungwon Univ.' 'Taepyeong' 'Moran' 'Yatap' 'Imae' 'Seohyeon' 'Sunae' 'Jeongja' 'Migeum' 'Ori' 'Jukjeon' 'Bojeong') inject: 215 into: [:integer :each | 
		inst addStationNamed: each idNumber: integer.  
		integer := integer+1 ].
	inst connectStationsWithEdgesWithTimeSpanMinutes: #(2 2 2 2 2 4 4 3 2 2 3 3 2 2 3 3 2 3 2).
	^inst! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/29/2009 11:31'!
line6
	
	| instance |
	instance := self new.
	instance line: '6'.
	instance idPrefix: ''.
	#('Eungam' 'Yeokchon' 'Bulgwang' 'Dokbawi' 'Yeonsinnae' 'Gusan' 'Saejeol
(Sinsa)' 'Jeungsan
(Myongji Univ.)'	 'Digital Media City' 'World Cup Stadium
(Seongsan)' 'Mapo-gu Office' 'Mangwon' 'Hapjeong' 'Sangsu' 'Gwangheungchang (Seogang)' 'Daeheung
(Sogang Univ.)' 'Gongdeok' 'Hyochang Park
(Yongsan-gu Office)' 'Samgakji' 'Noksapyeong' 'Itaewon' 'Hangangjin' 'Beotigogae' 'Yaksu' 'Cheonggu' 'Sindang' 'Dongmyo' 'Changsin' 'Bomun' 'Anam
(Korea Univ. Hospital)' 'Korea Univ.
(Jongam)' 'Wolgok
(Dongduk Women''s Univ.)'	 'Sangwolgok
(KIST)' 'Dolgoji' 'Seokgye' 'Taereung' 'Hwarangdae
(Seoul Women''s Univ.)' 'Bonghwasan')  inject: 610 into: [:integer :each | 
		instance addStationNamed: each idNumber: integer.  
		integer := integer+1 ].
	instance connectStationsInRange: (Array with: 1), (7 to: 38) withEdgesWithTimeSpanMinutes: (32 copiesOf: 2).
	instance connectStationsWithDirectionInRange: (1 to: 6) , (1 to: 1) withEdgesWithTimeSpanMinutes: #(2 2 2 3 2 3).
	^instance! !

!JhcLine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/28/2009 15:19'!
line8

	| instance |
	instance := self new.
	instance line: '8'.
	instance idPrefix: ''.
	#('Amsa' 'Cheonho(Pungnaptoseong)' 'Gangdong-gu Office' 'Mongchontoseong(World Peace Gate)' 'Jamsil(Songpa-gu Office)' 'Seokchon' 'Songpa' 'Garak Market' 'Munjeong' 'Jangji' 'Bokjeong' 'Sanseong' 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' 'Dandaegogeori' 'Sinheung' 'Sujin' 'Moran') inject: 810 into: [:integer :each | 
		instance addStationNamed: each idNumber: integer.  
		integer := integer+1 ].
	
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(2 2 3 2 2 2 2 2 2 2 4 3 2 2 2 2).
	^instance! !

!JhcLine methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:50'!
addStationNamed: aByteString 
	^self addStationNamed: aByteString idNumber: self nextIdNumber! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:49'!
addStationNamed: aByteString idNumber: aSmallInteger 

	^stations add: (JhcStation newName: aByteString line: line id: idPrefix , aSmallInteger printString)
! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:12'!
connectStationsInRange: indicesOfStation withEdgesWithTimeSpanMinutes: minutes 

	| minutesStream |
	minutesStream := minutes readStream.
	(indicesOfStation collect: [:each| stations at: each]) doCouple: [:a :b| a connect: b cost: minutesStream next ].! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:12'!
connectStationsWithDirectionInRange: indicesOfStation withEdgesWithTimeSpanMinutes: minutes 

	| minutesStream |
	minutesStream := minutes readStream.
	(indicesOfStation collect: [:each| stations at: each]) doCouple: [:a :b| a connectTo: b  cost: minutesStream next ].! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:13'!
connectStationsWithEdgesTimeSpan2Minutes

	stations doCouple: [:a :b| a connect: b cost: a class defaultCost ].! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:12'!
connectStationsWithEdgesWithTimeSpanMinutes: anArray 

	| minutesStream |
	minutesStream := anArray readStream.
	stations doCouple: [:a :b| a connect: b cost: minutesStream next ].
	! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 21:58'!
idPrefix: aByteString 

	idPrefix := aByteString ! !

!JhcLine methodsFor: 'initialize-release' stamp: 'hjo 9/27/2009 22:00'!
initialize

	super initialize.
	stations := OrderedCollection new! !

!JhcLine methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:33'!
integerStream
	integerStream isNil ifTrue: [ integerStream := IntegerStream new ].
	^integerStream! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 21:58'!
line: aByteString 

	line :=  aByteString ! !

!JhcLine methodsFor: 'query' stamp: 'jhan 10/2/2009 00:48'!
neighbors
	self shouldBeImplemented! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:32'!
nextIdNumber
	^self integerStream next! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 22:27'!
stations

	^stations! !

Object subclass: #JhcSegment
	instanceVariableNames: 'timespanMinutes graphEdge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcSegment classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:15'!
newTimespanMinutes: aNumber

	^self new
		timespanMinutes: aNumber 

	! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 18:52'!
graphEdge

	^graphEdge! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/26/2009 19:25'!
initialize

	super initialize.
	graphEdge := CostEdge new.! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:22'!
timespanMinutes

	^timespanMinutes! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/26/2009 19:36'!
timespanMinutes: aNumber

	self revisit: 'duplicate information!!'.
	timespanMinutes := aNumber.
	graphEdge cost: aNumber! !

Object subclass: #JhcStation
	instanceVariableNames: 'name id line graphVertex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 01:03'!
defaultCost
	^2! !

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 18:05'!
newName: aByteString line: aSmallInteger id: aSmallInteger3 

	^self new
		name: aByteString;
		line: aSmallInteger;
		id: aSmallInteger3! !

!JhcStation methodsFor: 'testing' stamp: 'jhan 10/2/2009 01:06'!
canDirectlyGo: aJhcStation
	^graphVertex neighboringVertices anySatisfy: [:each| each masterObject = aJhcStation]! !

!JhcStation methodsFor: 'testing' stamp: 'hjo 9/26/2009 19:27'!
canGo: aJhcStation in: aJhcSegment 

	^graphVertex leavingEdges anySatisfy: [:each| each masterObject == aJhcSegment ]
! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:03'!
connect: aJhcStation 
	self connect: aJhcStation cost: self class defaultCost! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:00'!
connect: other cost: c 
	self graphVertex connect: other graphVertex cost: c! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:14'!
connectTo: otherStation cost: aSmallInteger 
	self graphVertex connectTo: otherStation graphVertex cost: aSmallInteger! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/26/2009 19:30'!
graphVertex

	^graphVertex! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/27/2009 22:31'!
id

	^id! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
id: aSmallInteger 

	id := aSmallInteger! !

!JhcStation methodsFor: 'initialize-release' stamp: 'hjo 9/29/2009 11:11'!
initialize

	super initialize.
	graphVertex := CostVertex new.
	graphVertex masterObject: self! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/18/2009 13:47'!
line

	^line! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
line: aSmallInteger 

	line := aSmallInteger! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:01'!
name

	^name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
name: aByteString 
	name := aByteString! !

!JhcStation methodsFor: 'querying' stamp: 'jhan 10/2/2009 00:54'!
neighbors
	^self graphVertex neighbors collect: [ :neighbor | neighbor masterObject ]! !

!JhcStation methodsFor: 'printing' stamp: 'hjo 9/28/2009 12:38'!
printVertexDetailOn: aStream

	aStream print: name! !

!JhcStation methodsFor: 'collecting' stamp: 'hjo 9/26/2009 20:18'!
setStationAccess: aJhcStation in: aJhcSegment 

	aJhcSegment graphEdge connect: self graphVertex and: aJhcStation graphVertex.
	self assert: [self graphVertex hasEdge: aJhcSegment graphEdge] description: 'Hand shake?'.
	self assert: [aJhcStation graphVertex hasEdge: aJhcSegment graphEdge] description: 'Hand shake?'! !

!JhcStation methodsFor: 'querying' stamp: 'hjo 9/29/2009 11:10'!
timespanMinutesTo: aJhcStation 

	self revisit: 'CostVertices in the Graph must be initialized some how.'.
	aJhcStation graphVertex computeMinimumCostGraphPathsFrom: self graphVertex.
	^aJhcStation graphVertex minimumCost! !

Object subclass: #JhcUnreachable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcUnreachable methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:26'!
timespanMinutes
	
	^Float infinity! !
